// glm::vec3 class test program
// -Kyoung Shin Park (2013 Spring)
//////////////////////////////////////////////////////////////////////
#include <iostream>
#include <glm/glm.hpp> 
#include <glm/gtc/type_ptr.hpp>
#include <glm/gtc/matrix_transform.hpp>

using namespace std;
using namespace glm;

float theta(const glm::vec3 &v1,  const glm::vec3 &v2)
{
	float len1 = (float)sqrt(v1[0]*v1[0] + v1[1]*v1[1] + v1[2]*v1[2]);
	float len2 = (float)sqrt(v2[0]*v2[0] + v2[1]*v2[1] + v2[2]*v2[2]);
	return (float)acos(dot(v1, v2)/len1*len2);
}

void vectorTest()
{
    const float v[3] = { 1.0f, 2.0f, 3.0f };
    vec3 a(0.0f, 0.0f, 0.0f), b(1.0f, 2.0f, 3.0f), c(b);
    vec3 d = c;
    vec3 e = c;
	vec3 f = a;
    cout << "a = " << a[0] << " " << a[1] << " " << a[2] << endl;
    cout << "b = " << b[0] << " " << b[1] << " " << b[2] << endl;
    cout << "c = " << c[0] << " " << c[1] << " " << c[2] << endl;
    cout << "d = " << d[0] << " " << d[1] << " " << d[2] << endl;
    cout << "e = " << e[0] << " " << e[1] << " " << e[2] << endl;
    a[0] = 4;
    a[1] = 5; 
    a[2] = 6;
    cout << "after assignments, a (4,5,6) " << endl;
    cout << "a = " << a[0] << " " << a[1] << " " << a[2] << endl;
    cout << "b = " << b[0] << " " << b[1] << " " << b[2] << endl;

	cout << "Unary Operation" << endl;
    a += b;
    cout << "a += b  " << endl;
    cout << "a = " << a[0] << " " << a[1] << " " << a[2] << endl;
    a -= b;
    cout << "a -= b  " << endl;
    cout << "a = " << a[0] << " " << a[1] << " " << a[2] << endl;
    a *= 1.5;
    cout << "a *= 1.5  " << endl;
    cout << "a = " << a[0] << " " << a[1] << " " << a[2] << endl;
    a /= 1.5;
    cout << "a /= 1.5  " << endl;
    cout << "a = " << a[0] << " " << a[1] << " " << a[2] << endl;

	cout << "Binary Operation" << endl;
    c = a + b;
    cout << "c = a + b  ->  c " << endl;
    cout << "c = " << c[0] << " " << c[1] << " " << c[2] << endl;
    c = a - b;
    cout << "c = a - b  ->  c " << endl;
    cout << "c = " << c[0] << " " << c[1] << " " << c[2] << endl;

    cout << "a == b" << endl;
    if (a == b)
        cout << " is true" << endl;
    else
        cout << " is false" << endl;

    cout << "b == d" << endl;
    if (b == d)
        cout << " is true" << endl;
    else
        cout << " is false" << endl;

	// magnitude
	cout << "a = " << a[0] << " " << a[1] << " " << a[2] << endl;
    cout << "b = " << b[0] << " " << b[1] << " " << b[2] << endl;
    cout << "a magnitude = " << (float)sqrt(a[0]*a[0] + a[1]*a[1] + a[2]*a[2]) << endl;
    cout << "b magnitude = " << (float)sqrt(b[0]*b[0] + b[1]*b[1] + b[2]*b[2]) << endl;
	
	// normalize
	c = normalize(a);
	cout << "c = normalize(a) = " << c[0] << " " << c[1] << " " << c[2] << endl;
	cout << "c magnitude = " << (float)sqrt(c[0]*c[0] + c[1]*c[1] + c[2]*c[2]) << endl;

	d = normalize(b);
	cout << "d = normalize(b) = " << d[0] << " " << d[1] << " " << d[2] << endl;
	cout << "d magnitude = " << (float)sqrt(d[0]*d[0] + d[1]*d[1] + d[2]*d[2]) << endl;
	
	// dot product, theta, cross product
	cout << "dot(a, b) = " << dot(a, b) << endl;
	cout << "a,b angle = " << degrees(theta(a, b)) << endl;
	e = cross(a, b);
	cout << "e = cross(a, b) = " << e[0] << " " << e[1] << " " << e[2] << endl;
	f = cross(vec3(1.0f, 3.0f, -4.0f), vec3(2.0f, -5.0f, 8.0f));
	cout << "(1, 3, -4) x (2, -5, 8) = " << f[0] << " " << f[1] << " " << f[2] << endl;
	
}

